using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using CarlosB.PathFind;

namespace Example
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmTestAStar : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnFind;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton rbtnRoad;
		private System.Windows.Forms.RadioButton rbtnSwamp;
		private System.Windows.Forms.RadioButton rbtnWall;
		private System.Windows.Forms.RadioButton rbtnSand;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.PictureBox pbxMap;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;

		private const float FONT_SCALE = 0.75f;
		private const byte ROAD_COST = 0,
			SWAMP_COST = 170,
			SAND_COST = 85,
			WALL_COST = 255;

		private Point[] PathSteps;
		private float NodeWidth,
			NodeHeight,
			FontSize;
		private Point StartPos, FinishPos;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton tbbtnStart;
		private System.Windows.Forms.ToolBarButton tbbtnFinish;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown nudMaxSteps;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label lblAverage;
		private System.Windows.Forms.NumericUpDown nudRepetitions;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label lblWeight;
		private System.Windows.Forms.TrackBar tbrWeight;
		private CarlosB.PathFind.AStar AStarSearch;
		private bool ButtonPressed;

		public frmTestAStar()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			linkLabel1.Links.Add(0, 1000, "www.carlosb.com");

			AStarSearch.CellCost = new byte[AStarSearch.Width, AStarSearch.Height];
			for (int x=0; x<AStarSearch.Width; x++)
				for (int y=0; y<AStarSearch.Height; y++)
					AStarSearch.CellCost[x, y] = ROAD_COST;

			FinishPos.X = AStarSearch.Width-1;
			FinishPos.Y = AStarSearch.Height-1;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pbxMap = new System.Windows.Forms.PictureBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.lblWeight = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.tbrWeight = new System.Windows.Forms.TrackBar();
			this.lblAverage = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.nudRepetitions = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.nudMaxSteps = new System.Windows.Forms.NumericUpDown();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbbtnStart = new System.Windows.Forms.ToolBarButton();
			this.tbbtnFinish = new System.Windows.Forms.ToolBarButton();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.rbtnSand = new System.Windows.Forms.RadioButton();
			this.rbtnWall = new System.Windows.Forms.RadioButton();
			this.rbtnSwamp = new System.Windows.Forms.RadioButton();
			this.rbtnRoad = new System.Windows.Forms.RadioButton();
			this.btnFind = new System.Windows.Forms.Button();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.AStarSearch = new CarlosB.PathFind.AStar();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbrWeight)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudRepetitions)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudMaxSteps)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// pbxMap
			// 
			this.pbxMap.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pbxMap.BackColor = System.Drawing.Color.White;
			this.pbxMap.Name = "pbxMap";
			this.pbxMap.Size = new System.Drawing.Size(712, 420);
			this.pbxMap.TabIndex = 11;
			this.pbxMap.TabStop = false;
			this.pbxMap.Resize += new System.EventHandler(this.pbxMap_Resize);
			this.pbxMap.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			this.pbxMap.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pbxMap_MouseUp);
			this.pbxMap.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pbxMap_MouseMove);
			this.pbxMap.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pbxMap_MouseDown);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.lblWeight,
																				 this.label4,
																				 this.tbrWeight,
																				 this.lblAverage,
																				 this.label3,
																				 this.label2,
																				 this.nudRepetitions,
																				 this.label1,
																				 this.nudMaxSteps,
																				 this.toolBar1,
																				 this.linkLabel1,
																				 this.groupBox1,
																				 this.btnFind});
			this.panel1.Location = new System.Drawing.Point(0, 421);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(712, 92);
			this.panel1.TabIndex = 12;
			// 
			// lblWeight
			// 
			this.lblWeight.Location = new System.Drawing.Point(328, 68);
			this.lblWeight.Name = "lblWeight";
			this.lblWeight.Size = new System.Drawing.Size(64, 16);
			this.lblWeight.TabIndex = 32;
			this.lblWeight.Text = "label5";
			this.lblWeight.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(315, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(90, 13);
			this.label4.TabIndex = 31;
			this.label4.Text = "Heuristic Weight:";
			// 
			// tbrWeight
			// 
			this.tbrWeight.Location = new System.Drawing.Point(312, 32);
			this.tbrWeight.Maximum = 2550;
			this.tbrWeight.Minimum = 10;
			this.tbrWeight.Name = "tbrWeight";
			this.tbrWeight.Size = new System.Drawing.Size(96, 45);
			this.tbrWeight.TabIndex = 30;
			this.tbrWeight.TickFrequency = 255;
			this.tbrWeight.Value = 10;
			this.tbrWeight.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// lblAverage
			// 
			this.lblAverage.AutoSize = true;
			this.lblAverage.Location = new System.Drawing.Point(680, 48);
			this.lblAverage.Name = "lblAverage";
			this.lblAverage.Size = new System.Drawing.Size(10, 13);
			this.lblAverage.TabIndex = 29;
			this.lblAverage.Text = "0";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(576, 48);
			this.label3.Name = "label3";
			this.label3.TabIndex = 28;
			this.label3.Text = "Average time (ms):";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(424, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 13);
			this.label2.TabIndex = 27;
			this.label2.Text = "Repetitions:";
			// 
			// nudRepetitions
			// 
			this.nudRepetitions.Location = new System.Drawing.Point(488, 56);
			this.nudRepetitions.Maximum = new System.Decimal(new int[] {
																		   10000,
																		   0,
																		   0,
																		   0});
			this.nudRepetitions.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.nudRepetitions.Name = "nudRepetitions";
			this.nudRepetitions.Size = new System.Drawing.Size(64, 20);
			this.nudRepetitions.TabIndex = 26;
			this.nudRepetitions.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 0});
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(424, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(61, 13);
			this.label1.TabIndex = 25;
			this.label1.Text = "Max Steps:";
			// 
			// nudMaxSteps
			// 
			this.nudMaxSteps.Location = new System.Drawing.Point(488, 24);
			this.nudMaxSteps.Maximum = new System.Decimal(new int[] {
																		10000,
																		0,
																		0,
																		0});
			this.nudMaxSteps.Name = "nudMaxSteps";
			this.nudMaxSteps.Size = new System.Drawing.Size(64, 20);
			this.nudMaxSteps.TabIndex = 24;
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbbtnStart,
																						this.tbbtnFinish});
			this.toolBar1.ButtonSize = new System.Drawing.Size(34, 36);
			this.toolBar1.Divider = false;
			this.toolBar1.Dock = System.Windows.Forms.DockStyle.None;
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.Location = new System.Drawing.Point(224, 31);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(72, 37);
			this.toolBar1.TabIndex = 23;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbbtnStart
			// 
			this.tbbtnStart.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tbbtnStart.Text = "Start";
			// 
			// tbbtnFinish
			// 
			this.tbbtnFinish.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tbbtnFinish.Text = "Finish";
			// 
			// linkLabel1
			// 
			this.linkLabel1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.linkLabel1.Location = new System.Drawing.Point(568, 72);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(168, 16);
			this.linkLabel1.TabIndex = 21;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "Carlos Barbosa\'s Home Page";
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.rbtnSand,
																					this.rbtnWall,
																					this.rbtnSwamp,
																					this.rbtnRoad});
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(201, 76);
			this.groupBox1.TabIndex = 20;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Brush";
			// 
			// rbtnSand
			// 
			this.rbtnSand.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.rbtnSand.ForeColor = System.Drawing.Color.Black;
			this.rbtnSand.Location = new System.Drawing.Point(104, 19);
			this.rbtnSand.Name = "rbtnSand";
			this.rbtnSand.Size = new System.Drawing.Size(89, 18);
			this.rbtnSand.TabIndex = 3;
			this.rbtnSand.Text = "Sand (85)";
			// 
			// rbtnWall
			// 
			this.rbtnWall.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(64)), ((System.Byte)(0)));
			this.rbtnWall.ForeColor = System.Drawing.Color.Black;
			this.rbtnWall.Location = new System.Drawing.Point(104, 48);
			this.rbtnWall.Name = "rbtnWall";
			this.rbtnWall.Size = new System.Drawing.Size(89, 18);
			this.rbtnWall.TabIndex = 2;
			this.rbtnWall.Text = "Wall (255)";
			// 
			// rbtnSwamp
			// 
			this.rbtnSwamp.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.rbtnSwamp.ForeColor = System.Drawing.Color.Black;
			this.rbtnSwamp.Location = new System.Drawing.Point(8, 48);
			this.rbtnSwamp.Name = "rbtnSwamp";
			this.rbtnSwamp.Size = new System.Drawing.Size(89, 18);
			this.rbtnSwamp.TabIndex = 1;
			this.rbtnSwamp.Text = "Swamp (170)";
			// 
			// rbtnRoad
			// 
			this.rbtnRoad.BackColor = System.Drawing.Color.Silver;
			this.rbtnRoad.Checked = true;
			this.rbtnRoad.ForeColor = System.Drawing.Color.Black;
			this.rbtnRoad.Location = new System.Drawing.Point(10, 19);
			this.rbtnRoad.Name = "rbtnRoad";
			this.rbtnRoad.Size = new System.Drawing.Size(89, 18);
			this.rbtnRoad.TabIndex = 0;
			this.rbtnRoad.TabStop = true;
			this.rbtnRoad.Text = "Road (0)";
			// 
			// btnFind
			// 
			this.btnFind.Location = new System.Drawing.Point(584, 16);
			this.btnFind.Name = "btnFind";
			this.btnFind.Size = new System.Drawing.Size(88, 24);
			this.btnFind.TabIndex = 17;
			this.btnFind.Text = "Find";
			this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4,
																					  this.menuItem5});
			this.menuItem1.Text = "File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuItem2.Text = "Open...";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.menuItem3.Text = "Save...";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "Close";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.DefaultExt = "map";
			this.openFileDialog1.Filter = "Map files|*.map";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "map";
			this.saveFileDialog1.FileName = "doc1";
			this.saveFileDialog1.Filter = "Map files|*.map";
			// 
			// AStarSearch
			// 
			this.AStarSearch.Height = 40;
			this.AStarSearch.HeuristicWeight = 1F;
			this.AStarSearch.MaxSteps = 0;
			this.AStarSearch.Width = 60;
			// 
			// frmTestAStar
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(712, 513);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.panel1,
																		  this.pbxMap});
			this.Menu = this.mainMenu1;
			this.MinimumSize = new System.Drawing.Size(720, 250);
			this.Name = "frmTestAStar";
			this.Text = "A* Path Finding Example";
			this.Load += new System.EventHandler(this.frmTestAStar_Load);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbrWeight)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudRepetitions)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudMaxSteps)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmTestAStar());
		}

		private void DeletePath()
		{
			if (PathSteps != null)
			{
				PathSteps = null;
				pbxMap.Invalidate();
			}
		}
		
		private void ResizeMap()
		{
			NodeWidth = (float)pbxMap.Width / AStarSearch.Width;
			NodeHeight = (float)pbxMap.Height / AStarSearch.Height;
			FontSize = (int)(Math.Min(NodeWidth, NodeHeight) * FONT_SCALE);
			pbxMap.Invalidate();
		}
		
		private void LoadFile(String FileName)
		{
			PathSteps = null;

			BinaryReader BR = new BinaryReader(File.OpenRead(FileName));
			AStarSearch.Width = BR.ReadInt32();
			AStarSearch.Height = BR.ReadInt32();
			AStarSearch.CellCost = new byte[AStarSearch.Width, AStarSearch.Height];
			StartPos.X = BR.ReadInt32();
			StartPos.Y = BR.ReadInt32();
			FinishPos.X = BR.ReadInt32();
			FinishPos.Y = BR.ReadInt32();
			for (int x=0; x<AStarSearch.Width; x++)
				for (int y=0; y<AStarSearch.Height; y++)
					AStarSearch.CellCost[x, y] = BR.ReadByte();
			
			ResizeMap();
		}
		
		private void SaveFile(String FileName)
		{
			PathSteps = null;

			BinaryWriter BW = new BinaryWriter(File.OpenWrite(FileName));
			BW.Write(AStarSearch.Width);
			BW.Write(AStarSearch.Height);
			BW.Write(StartPos.X);
			BW.Write(StartPos.Y);
			BW.Write(FinishPos.X);
			BW.Write(FinishPos.Y);
			for (int x=0; x<AStarSearch.Width; x++)
				for (int y=0; y<AStarSearch.Height; y++)
					BW.Write(AStarSearch.CellCost[x, y]);
		}

		private void ProcessButtonOnMap(System.Windows.Forms.MouseEventArgs e)
		{
			DeletePath();

			int CellX = (int)(e.X / NodeWidth);
			int CellY = (int)(e.Y / NodeHeight);
			if ((CellX < 0) || (CellX >= AStarSearch.Width) || (CellY < 0) || (CellY >= AStarSearch.Height))
				return;

			if (tbbtnStart.Pushed)
			{
				StartPos = new Point(CellX, CellY);
				pbxMap.Invalidate();
			}
			else
				if (tbbtnFinish.Pushed)
				{	
					FinishPos = new Point(CellX, CellY);
					pbxMap.Invalidate();
				}
				else
				{
					byte Value;
					if (rbtnRoad.Checked)
						Value = ROAD_COST;
					else
						if (rbtnSwamp.Checked)
						Value = SWAMP_COST;
					else
						if (rbtnSand.Checked)
						Value = SAND_COST;
					else
						Value = WALL_COST;

					if (AStarSearch.CellCost[CellX, CellY] == Value)
						return;

					AStarSearch.CellCost[CellX, CellY] = Value;
					pbxMap.Invalidate(new Rectangle((int)(CellX * NodeWidth), (int)(CellY * NodeHeight),
						(int)((CellX+1) * NodeWidth), (int)((CellY+1) * NodeHeight)));
				}
		}

		private void RefreshWeight()
		{
			lblWeight.Text = AStarSearch.HeuristicWeight.ToString();
		}

		private void btnFind_Click(object sender, System.EventArgs e)
		{
			int Cost;
			PathSteps = null;
			AStarSearch.MaxSteps = (int)nudMaxSteps.Value;

			int InitTime = Environment.TickCount;
			for (int cnt=0; cnt<nudRepetitions.Value; cnt++)
				if (AStarSearch.FindPath(StartPos, FinishPos, ref PathSteps, out Cost) < 0)
				{
					MessageBox.Show("Could not find a path");
					break;
				}
			lblAverage.Text = ((Environment.TickCount - InitTime) / nudRepetitions.Value).ToString();
			pbxMap.Invalidate();
		}

		private void linkLabel1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			// Determine which link was clicked within the LinkLabel.
			linkLabel1.Links[0].Visited = true;
			// Display the appropriate link based on the value of the LinkData property of the Link object.
			System.Diagnostics.Process.Start(e.Link.LinkData.ToString());
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			SolidBrush RoadBrush = new SolidBrush(rbtnRoad.BackColor),
				SwampBrush = new SolidBrush(rbtnSwamp.BackColor),
				SandBrush = new SolidBrush(rbtnSand.BackColor),
				WallBrush = new SolidBrush(rbtnWall.BackColor),
				CurrentBrush = null;
			Rectangle CellRect = new Rectangle(0, 0, (int)NodeWidth+1, (int)NodeHeight+1);

			for (int y=0; y<AStarSearch.Height; y++)
			{
				CellRect.Y = (int)(y * NodeHeight);

				for (int x=0; x<AStarSearch.Width; x++)
				{
					CellRect.X = (int)(x * NodeWidth);

					switch (AStarSearch.CellCost[x, y])
					{
						case ROAD_COST:
							CurrentBrush = RoadBrush;
							break;
						case SWAMP_COST:
							CurrentBrush = SwampBrush;
							break;
						case SAND_COST:
							CurrentBrush = SandBrush;
							break;
						case WALL_COST:
							CurrentBrush = WallBrush;
							break;
					}

					// draw cell color
					e.Graphics.FillRectangle(CurrentBrush, CellRect);

					// draw start symbol
					if ((StartPos.X == x) && (StartPos.Y == y))
						e.Graphics.DrawString("S", new Font("Arial", FontSize), new SolidBrush(Color.Black), CellRect);

					// draw finish symbol
					if ((FinishPos.X == x) && (FinishPos.Y == y))
						e.Graphics.DrawString("F", new Font("Arial", FontSize), new SolidBrush(Color.Black), CellRect);
				}
			}				

			// draw path found
			if (PathSteps != null)
				foreach (Point Node in PathSteps)
				{
					CellRect.X = (int)(Node.X * NodeWidth);
					CellRect.Y = (int)(Node.Y * NodeHeight);
					e.Graphics.DrawString("x", new Font("Arial", FontSize), new SolidBrush(Color.Brown), CellRect);
				}
		}

		private void pbxMap_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (ButtonPressed)
				ProcessButtonOnMap(e);
		}

		private void pbxMap_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				ButtonPressed = true;
				ProcessButtonOnMap(e);
			}
		}

		private void pbxMap_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
				ButtonPressed = false;

			tbbtnFinish.Pushed = false;
			tbbtnStart.Pushed = false;
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.ShowDialog() == DialogResult.OK)
				LoadFile(openFileDialog1.FileName);
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			if (saveFileDialog1.ShowDialog() == DialogResult.OK)
				SaveFile(saveFileDialog1.FileName);
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == tbbtnStart)
				tbbtnFinish.Pushed &= (!tbbtnStart.Pushed);
			else
				tbbtnStart.Pushed &= (!tbbtnFinish.Pushed);
		}

		private void pbxMap_Resize(object sender, System.EventArgs e)
		{
			ResizeMap();
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			AStarSearch.HeuristicWeight = (float)tbrWeight.Value / 10;
			RefreshWeight();
		}

		private void frmTestAStar_Load(object sender, System.EventArgs e)
		{
			RefreshWeight();
			openFileDialog1.InitialDirectory = Directory.GetCurrentDirectory();
			saveFileDialog1.InitialDirectory = Directory.GetCurrentDirectory();
			
			// reads example file at startup
			LoadFile(Directory.GetCurrentDirectory() + "\\maze.map");
		}

		private void AStarSearch_EstimateGoalCost(object sender, CarlosB.PathFind.EstimateGoalCostEventArgs e)
		{
//			e.Result = (int)(Math.Sqrt(Math.Pow(e.From.X - e.To.X, 2) +  Math.Pow(e.From.Y - e.To.Y, 2)));
		}

		private void AStarSearch_Cell(object sender, CarlosB.PathFind.CellEventArgs e)
		{
//			e.Result = (byte)e.Pos.Y;
		}

	}
}
